
import oracle.xquery.XQueryContext;
import oracle.xquery.PreparedXQuery;
import oracle.xquery.XQueryResultSet;
import oracle.xquery.exec.Utils;
import oracle.xml.parser.v2.XMLNode;
import oracle.xml.parser.v2.DOMParser;
import oracle.xml.parser.v2.XMLDocument;

import java.io.InputStream;

/**
 * Created by IntelliJ IDEA.
 * User: PadmaNathan
 * Date: Mar 17, 2003
 * Time: 11:10:17 PM
 * Example shows how to dynamically bind xml files to query and execute XQuery
 */
public class OracleXQueryBindDemo {
    public static void main(String argv[]) {
        //Prepare XQuery Context.
        XQueryContext ctx = new XQueryContext();

        try {
            // Prepare the XQuery String with a bind variable
            PreparedXQuery xq = ctx.prepareXQuery(
                    " for $b IN bind('1')/bib/book            " +
                    " WHERE $b/publisher = 'Addison-Wesley' " +
                    "   AND $b/@year > 1991                 " +
                    "    RETURN  <book year=' $b/@year '>   " +
                    "            { $b/title }  </book>      ");

            //use a DOM parser to read the XML stream.
            DOMParser prs = new DOMParser();
            InputStream is = Utils.getStream("c:\\nathannewbook\\j2eebible\\bib.xml");
            prs.parse(is);

            XMLDocument doc = prs.getDocument();
            //bind the xml stream in DOM to the bind variable "1" in XQuery.
            xq.setNode((new Integer("1")).toString(), doc);

            // System.out.println(" Executing Query ");
            //Execute the result set
            XQueryResultSet rset = xq.executeQuery(false);
            int pos = 0;
            //print the nodes.
            while (rset.next()) {
                // System.out.println(" ---- Fetching Node[" + pos + "] ---- ");
                pos++;

                XMLNode node = rset.getNode();
                // System.out.println(" NODE " + node.getNodeName());
                node.print(System.out);
            }
        } catch (Exception e) {
            System.out.println(" got exception " + e.getMessage());
        }
    }
}
